// soukrom konstanty

// konstanty pro hodnoty promnn modCesta_ZpsobZadvnMst
# define modCesta_ZADVNMST_SELN 1
# define modCesta_ZADVNMST_GRAFICKY 2
// konstanty pro hodnoty promnn modCesta_JakSouetSpojnicHledat
# define modCesta_NEJMEN_SOUET 1
# define modCesta_NEJVT_SOUET 2

// soukrom promnn

int modCesta_PoetMst; // poet mst, kter lze navtvit
int *modCesta_SouadniceMst; // souadnice mst, kter lze navtvit (kad sud [0,2,4..] prvek je X a kad lich [1,3,5..] prvek je Y)
int modCesta_ZpsobZadvnMst; // seln nebo graficky (viz konstanty)
int modCesta_PoetSpojnic; // poet spojnic, kter lze pi navtvovn mst pout
int modCesta_AtributJeDlkaSpojnice; // zda se maj atributy spojnic automaticky nastavovat na grafickou vzdlenost mst, kter spojnice spojuje
struct modCesta_TypSpojnice {
  int Msto1; // prvn z mst, kter tvo spojnici
  int Msto2; // druh z mst, kter tvo spojnici
  long Atribut; // hodnota atributu spojnice
  } *modCesta_Spojnice; // pole informac o spojnicch, kter lze pi navtvovn mst pout
int modCesta_JakSouetSpojnicHledat; // zda hledat nejmen nebo nejvt hodnotu promnn SouetSpojnic (viz konstanty)

int *modCesta_Cesta; // pole prv testovan cesty - jednotliv prvky jsou poadov sla spojnic, kter cestu tvo
long modCesta_SouetSpojnic; // souet hodnot atribut vech spojnic, ze kterch se prv testovan cesta skld
int modCesta_rove; // rove zanoen v backtrackingu (kolik spojnic je v prv testovan cest ptomno)
int *modCesta_Nejlepeen_Cesta; // kopie pole Cesta, kter je dosud nejlep nalezenm eenm
long modCesta_Nejlepeen_SouetSpojnic; // kopie promnn SouetSpojnic, kter je dosud nejlepm nalezenm eenm
int modCesta_Nejlepeen_rove; // kopie promnn rove, kter byla aktuln v dob nalezen nejlepho nalezenho een

// soukrom funkce

void modCesta_VykresliMapu(int *modCesta_VykreslovanPole, int modCesta_Vykreslovanrove) {
  int modCesta_VykreslovanPrvek, modCesta_VykreslovanMsto, modCesta_VykreslovanSpojnice;
  int modCesta_VykreslovanPsmenoX, modCesta_VykreslovanPsmenoY;
  // uschovn pvodn nastavench barev
  int modCesta_PvodnBarvy = GrBarvy();
  // smazn obrazovky
  GrNastavBarvuPozad(PalBov);
  GrSmaOkno();
  // vykreslen jednotlivch mst, kter lze navtvit
  GrNastavText(GrTextSPozadm);
  GrNastavBarvy(PalTmavModr<<4|Pallut);
  ekejNaVR();
  for(modCesta_VykreslovanMsto=0; modCesta_VykreslovanMsto<((!modCesta_VykreslovanPole && modCesta_Vykreslovanrove+1)?modCesta_Vykreslovanrove:modCesta_PoetMst); modCesta_VykreslovanMsto++) {
    // vykreslen psmennho oznaen vykreslovanho msta
    GrNastavPozici(modCesta_SouadniceMst[modCesta_VykreslovanMsto*2], modCesta_SouadniceMst[modCesta_VykreslovanMsto*2+1]);
    GrNastavPozici((GrPoziceX()<4)?0:(GrPoziceX()>631?627:GrPoziceX()-4), (GrPoziceY()<5)?0:(GrPoziceY()>437?432:GrPoziceY()-5));
    GrPiZnak('A'+modCesta_VykreslovanMsto);
    }
  GrNastavText(GrTextBezPozad);
  // vykreslen jednotlivch spojnic mezi msty, kter lze pi navtvovn mst pout
  GrNastavBarvuPoped(Palern);
  for(modCesta_VykreslovanSpojnice=0; modCesta_VykreslovanSpojnice<modCesta_PoetSpojnic; modCesta_VykreslovanSpojnice++) {
    ekejNaVR();
    // uren msta, ze kterho m vst vykreslovan ra
    modCesta_VykreslovanMsto = modCesta_Spojnice[modCesta_VykreslovanSpojnice].Msto1;
    // nastaven kurzoru na pozici msta, ze kterho m vst vykreslovan ra
    GrNastavPozici(modCesta_SouadniceMst[modCesta_VykreslovanMsto*2], modCesta_SouadniceMst[modCesta_VykreslovanMsto*2+1]);
    // uren msta, do kterho m vst vykreslovan ra
    modCesta_VykreslovanMsto = modCesta_Spojnice[modCesta_VykreslovanSpojnice].Msto2;
    // vykreslen ry spojujc prvn z mst tvoc spojnici s druhm z nich
    GrKresliLinkuDo(modCesta_SouadniceMst[modCesta_VykreslovanMsto*2], modCesta_SouadniceMst[modCesta_VykreslovanMsto*2+1]);
    }
  // pokud se m vykreslovat i cesta
  if(modCesta_VykreslovanPole) {
    // vykreslen spojnic mezi msty tvocmi vykreslovanou cestu
    GrNastavBarvuPoped(PalBl);
    GrNastavPozici(modCesta_SouadniceMst[0], modCesta_SouadniceMst[1]);
    modCesta_VykreslovanMsto = 0;
    for(modCesta_VykreslovanPrvek=0; modCesta_VykreslovanPrvek<=modCesta_Vykreslovanrove; modCesta_VykreslovanPrvek++) {
      ekejNaVR();
      // uren spojnice, kterou m pedstavovat vykreslovan ra
      modCesta_VykreslovanSpojnice = modCesta_VykreslovanPole[modCesta_VykreslovanPrvek];
      // uren msta, do kterho m vst vykreslovan ra (uren smru, kterm je spojnice prochzena)
      modCesta_VykreslovanMsto = (modCesta_Spojnice[modCesta_VykreslovanSpojnice].Msto1 == modCesta_VykreslovanMsto)?modCesta_Spojnice[modCesta_VykreslovanSpojnice].Msto2:modCesta_Spojnice[modCesta_VykreslovanSpojnice].Msto1;
      // nakreslen ry spojujc pedchoz msto s prv vykreslovanm
      // kresl se posledn msto a nekresl se nejlep een => nastaven odlin barvy ry k nmu vedouc
      if(modCesta_VykreslovanPole != modCesta_Nejlepeen_Cesta && modCesta_VykreslovanPrvek == modCesta_Vykreslovanrove) GrNastavBarvuPoped(Pallut);
      // nakreslen samotn ry
      GrKresliLinkuDo(modCesta_SouadniceMst[modCesta_VykreslovanMsto*2], modCesta_SouadniceMst[modCesta_VykreslovanMsto*2+1]);
      }
    }

  // navrcen pvodn nastavench barev
  GrNastavBarvy(modCesta_PvodnBarvy);
  }

int modCesta_ZjistiVzdlenostMst(int modCesta_Msto1, int modCesta_Msto2) {
  // zjitn vzdlenosti mezi dvma msty pomoc Pythagorovy vty
  return sqrt(sqr(abs(modCesta_SouadniceMst[modCesta_Msto1*2]-modCesta_SouadniceMst[modCesta_Msto2*2])) + sqr(abs(modCesta_SouadniceMst[modCesta_Msto1*2+1]-modCesta_SouadniceMst[modCesta_Msto2*2+1])));
  }

string modCesta_PoleCestyNaetzec(int *modCesta_PevdnPole, int *modCesta_Pevdnrove, long *modCesta_PevdnSouetSpojnic) {
  string modCesta_Vrtit = "A";
  int modCesta_PevdnSpojnice, modCesta_PevdnMsto = 0;
  int modCesta_PevdnPrvek;
  for(modCesta_PevdnPrvek=0; modCesta_PevdnPrvek<=*modCesta_Pevdnrove; modCesta_PevdnPrvek++) {
    modCesta_PevdnSpojnice = modCesta_PevdnPole[modCesta_PevdnPrvek];
    modCesta_PevdnMsto = (modCesta_Spojnice[modCesta_PevdnSpojnice].Msto1 == modCesta_PevdnMsto)?modCesta_Spojnice[modCesta_PevdnSpojnice].Msto2:modCesta_Spojnice[modCesta_PevdnSpojnice].Msto1;
    modCesta_Vrtit += (string)(char)('A'+modCesta_PevdnMsto);
    }
  modCesta_Vrtit += " (souet "+StrLslo(*modCesta_PevdnSouetSpojnic,-1)+")";
  return modCesta_Vrtit;
  }

// veejn funkce

void modCesta_Start(void) {
  // v ppad grafickho reimu:
  if(mod_ReimObrazovky == mod_GRAFICK_REIM) {
    // smazn obrazovky
    GrSmaOkno();
    // vykreslen mapy (pouze msta)
    modCesta_VykresliMapu(0, -1);
    }

  mod_VypiHlku("Po stisknut klvesy nebo tlatka myi se rozbhne vpoet...", mod_VYPIHLKU_NEEKEJ);
  VyprzdniFrontuKlves(); MyZapni();
  ekej(NaKlvesu|NaMy);
  VyprzdniFrontuKlves(); MyVypni();

  // smazn obrazovky v ppad textovho reimu
  if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
    TxtSmaObrazovku();
    }

  mod_VypiHlku("Probh vpoet...", mod_VYPIHLKU_NEEKEJ);

  // zaznamenn asu startu vpotu
  Systmovas(mod_asStart);

  // inicializace promnnch pouvanch vpotem
  mod_HledatDl = 1;
  modCesta_SouetSpojnic = 0;
  modCesta_rove = 0;
  modCesta_Nejlepeen_SouetSpojnic = (modCesta_JakSouetSpojnicHledat==modCesta_NEJMEN_SOUET?2147483647:0); // nejhor mon souet hodnot atribut spojnic - v rele nemon, bude nahrazen lepm u pi nalezen prvn vyhovujc cesty
  modCesta_Nejlepeen_rove = 0;

  // zapsn parametr vpotu do souboru, pokud si to uivatel pl
  if(mod_ZapisovatProtokol) {
    mod_ProtokolZapiStart1();
    SouborPietzec(mod_ZapisovatProtokol_Soubor, "Reim obrazovky: "+(mod_ReimObrazovky==mod_TEXTOV_REIM?"textov":"grafick")+"\n");
    SouborPietzec(mod_ZapisovatProtokol_Soubor, "Poet mst na map: "+StrLslo(modCesta_PoetMst,-1)+"\n");
    SouborPietzec(mod_ZapisovatProtokol_Soubor, "Zpsob zadvn mst: "+(modCesta_ZpsobZadvnMst==modCesta_ZADVNMST_SELN?"seln":"graficky")+"\n");
    SouborPietzec(mod_ZapisovatProtokol_Soubor, "Souadnice jednotlivch mst [X, Y]: ");
    int modCesta_ProchzenMsto;
    for(modCesta_ProchzenMsto=0; modCesta_ProchzenMsto<modCesta_PoetMst; modCesta_ProchzenMsto++) SouborPietzec(mod_ZapisovatProtokol_Soubor, StrLslo(modCesta_SouadniceMst[modCesta_ProchzenMsto*2],-1)+","+StrLslo(modCesta_SouadniceMst[modCesta_ProchzenMsto*2+1],-1)+" ");
    SouborPiNovdek(mod_ZapisovatProtokol_Soubor);
    SouborPietzec(mod_ZapisovatProtokol_Soubor, "Poet spojnic mezi msty: "+StrLslo(modCesta_PoetSpojnic,-1)+"\n");
    SouborPietzec(mod_ZapisovatProtokol_Soubor, "Jednotliv spojnice a jejich atributy [Msto1, Msto2, Atribut]: ");
    int modCesta_ProchzenSpojnice;
    for(modCesta_ProchzenSpojnice=0; modCesta_ProchzenSpojnice<modCesta_PoetSpojnic; modCesta_ProchzenSpojnice++) SouborPietzec(mod_ZapisovatProtokol_Soubor, (string)(char)('A'+modCesta_Spojnice[modCesta_ProchzenSpojnice].Msto1)+","+(string)(char)('A'+modCesta_Spojnice[modCesta_ProchzenSpojnice].Msto2)+","+StrLslo(modCesta_Spojnice[modCesta_ProchzenSpojnice].Atribut,-1)+" ");
    SouborPiNovdek(mod_ZapisovatProtokol_Soubor);
    SouborPietzec(mod_ZapisovatProtokol_Soubor, "Jak souet hodnot atribut hledat: "+(modCesta_JakSouetSpojnicHledat==modCesta_NEJMEN_SOUET?"nejmen":"nejvt")+"\n");
    SouborPietzec(mod_ZapisovatProtokol_Soubor, "Zobrazovan pozice: "+(mod_ZobrazovanPozice==mod_POUZE_EEN?"jen nalezen een":"i prbh hledn")+"\n");
    SouborPietzec(mod_ZapisovatProtokol_Soubor, "Vykat po nalezen novho nejlepho een na stisk klvesy: "+(mod_ekatNaKlvesu?"ano":"ne")+"\n");
    SouborPietzec(mod_ZapisovatProtokol_Soubor, "Zapisovat protokol o vpotu: "+(mod_ZapisovatProtokol?"ano":"ne")+"\n");
    SouborPietzec(mod_ZapisovatProtokol_Soubor, "Soubor protokolu: "+mod_ZapisovatProtokol_Nzev+"\n");
    mod_ProtokolZapiStart2();
    }
  }

void modCesta_Hotovo(void) {
  // uloen asu dokonen vpotu
  Systmovas(mod_asHotovo);
  // pekreslen mapy - vykreslen przdn mapy
  if(mod_ReimObrazovky == mod_GRAFICK_REIM) {
    modCesta_VykresliMapu(0, -1);
    }
  // v ppad grafickho reimu ppnut - oznmen dokonen vpotu
  if(mod_ReimObrazovky == mod_GRAFICK_REIM) { Tn(1000); ekej(1500); VypniTn(); }
  // pokud bylo vbec nalezeno njak nejlep een
  if((modCesta_JakSouetSpojnicHledat == modCesta_NEJMEN_SOUET && modCesta_Nejlepeen_SouetSpojnic < 2147483647) || (modCesta_JakSouetSpojnicHledat == modCesta_NEJVT_SOUET && modCesta_Nejlepeen_SouetSpojnic > 0)) {
    // pekreslen mapy - vykreslen nejlepho nalezenho een
    if(mod_ReimObrazovky == mod_GRAFICK_REIM) {
      modCesta_VykresliMapu(modCesta_Nejlepeen_Cesta, modCesta_Nejlepeen_rove);
      }
    }
  // vpoet doby trvn vpotu
  mod_VpoetDobyTrvnVpotu();
  // zobrazen doby trvn vpotu
  mod_VypiHlku("Hotovo. Dlka: "+StrLsloZeroPad(mod_asRozdl.Hodiny,2)+":"+StrLsloZeroPad(mod_asRozdl.Minuty,2)+":"+StrLsloZeroPad(mod_asRozdl.Sekundy,2)+"."+StrLsloZeroPad(mod_asRozdl.Setiny,2)+"...", mod_VYPIHLKU_EKEJNAKLVESUGRAFIKA);
  // zapsn informac tkajcch se dokonen vpotu do souboru, pokud si to uivatel pl
  if(mod_ZapisovatProtokol) {
    // pokud bylo vbec nalezeno njak nejlep een
    if((modCesta_JakSouetSpojnicHledat == modCesta_NEJMEN_SOUET && modCesta_Nejlepeen_SouetSpojnic < 2147483647) || (modCesta_JakSouetSpojnicHledat == modCesta_NEJVT_SOUET && modCesta_Nejlepeen_SouetSpojnic > 0)) {
      SouborPietzec(mod_ZapisovatProtokol_Soubor, "NEJLEP EEN: ");
      SouborPietzec(mod_ZapisovatProtokol_Soubor, modCesta_PoleCestyNaetzec(modCesta_Nejlepeen_Cesta, &modCesta_Nejlepeen_rove, &modCesta_Nejlepeen_SouetSpojnic));
      SouborPiNovdek(mod_ZapisovatProtokol_Soubor);
      }
    // jinak pokud nebylo nalezeno dn nejlep een
    else {
      SouborPietzec(mod_ZapisovatProtokol_Soubor, "Nebylo nalezeno dn een.\n");
      }
    SouborPietzec(mod_ZapisovatProtokol_Soubor, "Hotovo: "+StrLsloZeroPad(mod_asHotovo.Hodiny,2)+":"+StrLsloZeroPad(mod_asHotovo.Minuty,2)+":"+StrLsloZeroPad(mod_asHotovo.Sekundy,2)+"."+StrLsloZeroPad(mod_asHotovo.Setiny,2)+"\n");
    SouborPietzec(mod_ZapisovatProtokol_Soubor, "Dlka vpotu: "+StrLsloZeroPad(mod_asRozdl.Hodiny,2)+":"+StrLsloZeroPad(mod_asRozdl.Minuty,2)+":"+StrLsloZeroPad(mod_asRozdl.Sekundy,2)+"."+StrLsloZeroPad(mod_asRozdl.Setiny,2)+"\n");
    mod_ProtokolZapiHotovo();
    }
  // pokud bylo vbec nalezeno njak nejlep een
  if((modCesta_JakSouetSpojnicHledat == modCesta_NEJMEN_SOUET && modCesta_Nejlepeen_SouetSpojnic < 2147483647) || (modCesta_JakSouetSpojnicHledat == modCesta_NEJVT_SOUET && modCesta_Nejlepeen_SouetSpojnic > 0)) {
    mod_VypiHlku("NEJLEP EEN: " + modCesta_PoleCestyNaetzec(modCesta_Nejlepeen_Cesta, &modCesta_Nejlepeen_rove, &modCesta_Nejlepeen_SouetSpojnic), mod_VYPIHLKU_EKEJNAKLVESU);
    }
  // jinak pokud nebylo nalezeno dn nejlep een
  else {
    mod_VypiHlku("Nebylo nalezeno dn een.", mod_VYPIHLKU_EKEJNAKLVESU);
    }
  }

void modCesta_klid(void) {
  // uvolnn pamti pouit pro pole souadnic mst
  HromadaUvolniPam؜(modCesta_SouadniceMst);
  modCesta_SouadniceMst = 0;
  // uvolnn pamti pouit pro pole spojnic
  HromadaUvolniPam؜(modCesta_Spojnice);
  modCesta_Spojnice = 0;
  // uvolnn pamti pouit pro pole cesty
  HromadaUvolniPam؜(modCesta_Cesta);
  modCesta_Cesta = 0;
  // uvolnn pamti pouit pro pole nejlepho een
  HromadaUvolniPam؜(modCesta_Nejlepeen_Cesta);
  modCesta_Nejlepeen_Cesta = 0;
  }

void modCesta_ZadnVstupu(void) {
  // INICIALIZACE REIMU OBRAZOVKY
  if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
    // pepnut do textovho reimu
    PepniNaText();
    }
  else if(mod_ReimObrazovky == mod_GRAFICK_REIM) {
    GrSmaOkno();
    }

  // INFORMACE O REIMU OBRAZOVKY
  if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
    mod_VypiHlku("Pouvm textov reim...", mod_VYPIHLKU_VYKEJ);
    }
  else if(mod_ReimObrazovky == mod_GRAFICK_REIM) {
    mod_VypiHlku("Pouvm grafick reim...", mod_VYPIHLKU_VYKEJ);
    }

  // INICIALIZACE PROMNNCH, KTER JE POTEBA MT INICIALIZOVAN JI PED JEJICH ZADNM
  modCesta_PoetMst = 0;
  modCesta_PoetSpojnic = 0;

  // ZJITN POTU MST NA MAP, KTER JE MONO PROJT
  mod_VypiHlku("Zadejte, kolik mst na map chcete vloit [2-26]: ", mod_VYPIHLKU_NEEKEJ);
  if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
    while((VyprzdniFrontuKlves(),TxttiIslo(modCesta_PoetMst)) || modCesta_PoetMst < 2 || modCesta_PoetMst > 26);
    }
  else if(mod_ReimObrazovky == mod_GRAFICK_REIM) {
    GrNastavVstup(mod_GRAFIKA_VSTUP_POKYN);
    while((VyprzdniFrontuKlves(),GrtiIslo("",modCesta_PoetMst,2,0,PalTmavModr<<4|Pallut)) || modCesta_PoetMst < 2 || modCesta_PoetMst > 26);
    GrNastavVstup(mod_GRAFIKA_VSTUP_MOJEPLOCHA);
    }

  // INFORMACE O POTU MST NA MAP, KTER JE MONO PROJT
  if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
    mod_VypiHlku("Budete vkldat "+StrLslo(modCesta_PoetMst,-1)+" mst...", mod_VYPIHLKU_VYKEJ);
    }

  // PPRAVA POLE SOUADNIC MST
  // alokace pamti pro pole
  modCesta_SouadniceMst = (int*)HromadaAlokujPam؜(modCesta_PoetMst*2*sizeof(modCesta_SouadniceMst[0]));
  // vynulovn vech prvk pole
  memset(modCesta_SouadniceMst, 0, modCesta_PoetMst*2*sizeof(modCesta_SouadniceMst[0]));

  // PPRAVA POLE CESTY
  // alokace pamti pro pole
  modCesta_Cesta = (int*)HromadaAlokujPam؜((modCesta_PoetMst-1)*sizeof(modCesta_Cesta[0]));
  // vynulovn vech prvk pole
  memset(modCesta_Cesta, 0, (modCesta_PoetMst-1)*sizeof(modCesta_Cesta[0]));

  // PPRAVA POLE NEJLEPHO EEN
  // alokace pamti pro pole
  modCesta_Nejlepeen_Cesta = (int*)HromadaAlokujPam؜((modCesta_PoetMst-1)*sizeof(modCesta_Nejlepeen_Cesta[0]));
  // vynulovn vech prvk pole
  memset(modCesta_Nejlepeen_Cesta, 0, (modCesta_PoetMst-1)*sizeof(modCesta_Nejlepeen_Cesta[0]));

  // ZJITN ZPSOBU ZADVN SOUADNIC JEDNOTLIVCH MST NA MAP, KTER JE MONO PROJT
  if(mod_ReimObrazovky == mod_GRAFICK_REIM) {
    // pokud je vybrn grafick reim, umonme zpsob zadvn vybrat
    mod_NechZvolit_Volby[0] = "seln"; mod_NechZvolit_AccessKeys[0] = '';
    mod_NechZvolit_Volby[1] = "graficky"; mod_NechZvolit_AccessKeys[1] = 'g';
    switch(mod_NechZvolit("Zvolte zpsob zadvn souadnic mst na map:")) {
      case 0: modCesta_ZpsobZadvnMst = modCesta_ZADVNMST_SELN; break;
      case 1: modCesta_ZpsobZadvnMst = modCesta_ZADVNMST_GRAFICKY; break;
      }
    }
  else if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
    // jinak pokud je vybrn textov reim, lze zadvat pouze seln
    modCesta_ZpsobZadvnMst = modCesta_ZADVNMST_SELN;
    }

  // ZJITN SOUADNIC JEDNOTLIVCH MST NA MAP, KTER JE MONO PROJT
  int modCesta_ZadvanMsto;
  if(modCesta_ZpsobZadvnMst == modCesta_ZADVNMST_SELN) {
    for(modCesta_ZadvanMsto=0; modCesta_ZadvanMsto<modCesta_PoetMst; modCesta_ZadvanMsto++) {
      // ZJITN X SOUADNICE PRV ZADVANHO MSTA
      mod_VypiHlku("Zadejte X souadnici msta "+(string)(char)('A'+modCesta_ZadvanMsto)+" v pixelech [0-635]: ", mod_VYPIHLKU_NEEKEJ);
      if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
        while((VyprzdniFrontuKlves(),TxttiIslo(modCesta_SouadniceMst[modCesta_ZadvanMsto*2])) || modCesta_SouadniceMst[modCesta_ZadvanMsto*2] < 0 || modCesta_SouadniceMst[modCesta_ZadvanMsto*2] > 635);
        }
      else if(mod_ReimObrazovky == mod_GRAFICK_REIM) {
        GrNastavVstup(mod_GRAFIKA_VSTUP_POKYN);
        while((VyprzdniFrontuKlves(),GrtiIslo("",modCesta_SouadniceMst[modCesta_ZadvanMsto*2],3,0,PalTmavModr<<4|Pallut)) || modCesta_SouadniceMst[modCesta_ZadvanMsto*2] < 0 || modCesta_SouadniceMst[modCesta_ZadvanMsto*2] > 635);
        GrNastavVstup(mod_GRAFIKA_VSTUP_MOJEPLOCHA);
        }

      // ZJITN Y SOUADNICE PRV ZADVANHO MSTA
      mod_VypiHlku("Zadejte Y souadnici msta "+(string)(char)('A'+modCesta_ZadvanMsto)+" v pixelech [0-442]: ", mod_VYPIHLKU_NEEKEJ);
      if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
        while((VyprzdniFrontuKlves(),TxttiIslo(modCesta_SouadniceMst[modCesta_ZadvanMsto*2+1])) || modCesta_SouadniceMst[modCesta_ZadvanMsto*2+1] < 0 || modCesta_SouadniceMst[modCesta_ZadvanMsto*2+1] > 442);
        }
      else if(mod_ReimObrazovky == mod_GRAFICK_REIM) {
        GrNastavVstup(mod_GRAFIKA_VSTUP_POKYN);
        while((VyprzdniFrontuKlves(),GrtiIslo("",modCesta_SouadniceMst[modCesta_ZadvanMsto*2+1],3,0,PalTmavModr<<4|Pallut)) || modCesta_SouadniceMst[modCesta_ZadvanMsto*2+1] < 0 || modCesta_SouadniceMst[modCesta_ZadvanMsto*2+1] > 442);
        GrNastavVstup(mod_GRAFIKA_VSTUP_MOJEPLOCHA);
        }

      // ZOBRAZEN PRV ZADVANHO MSTA SPOLU S OSTATNMI JI ZADANMI
      if(mod_ReimObrazovky == mod_GRAFICK_REIM) {
        modCesta_VykresliMapu(0, modCesta_ZadvanMsto+1);
        }

      // INFORMACE O SOUADNICI PRV ZADVANHO MSTA
      if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
        mod_VypiHlku("Souadnice msta "+(string)(char)('A'+modCesta_ZadvanMsto)+" je "+StrLslo(modCesta_SouadniceMst[modCesta_ZadvanMsto*2],-1)+","+StrLslo(modCesta_SouadniceMst[modCesta_ZadvanMsto*2+1],-1)+"...", mod_VYPIHLKU_VYKEJ);
        }
      }
    }
  else if(modCesta_ZpsobZadvnMst == modCesta_ZADVNMST_GRAFICKY) {
    NastavJmnoBankyPedmt("*\\backtraq");
    MyZapni();
    MyNastavGrKurzor(25);
    MyNastavPozici(mod_GRAFIKA_VSTUP_MOJEPLOCHA_X1+(mod_GRAFIKA_VSTUP_MOJEPLOCHA_X2-mod_GRAFIKA_VSTUP_MOJEPLOCHA_X1)/2, mod_GRAFIKA_VSTUP_MOJEPLOCHA_Y1+(mod_GRAFIKA_VSTUP_MOJEPLOCHA_Y2-mod_GRAFIKA_VSTUP_MOJEPLOCHA_Y1)/2);
    for(modCesta_ZadvanMsto=0; modCesta_ZadvanMsto<modCesta_PoetMst; modCesta_ZadvanMsto++) {
      // ZJITN X SOUADNICE PRV ZADVANHO MSTA
      mod_VypiHlku("Pomoc myi zadejte souadnici msta "+(string)(char)('A'+modCesta_ZadvanMsto)+".", mod_VYPIHLKU_NEEKEJ);
      // vykreslen mapy - pouze dosud zadan msta
      modCesta_VykresliMapu(0, modCesta_ZadvanMsto);
      // nastaven a zobrazen myi
      MyVyprzdniFrontuUdlost();
      MyZobrazKurzor();
      // vykn na volbu pozice prv zadvanho msta
      do{
        MytiUdlost(gMyUdlost);
        }while(gMyUdlost.Typ != MyUdlostLevTlNahoru);
      gMyUdlost.X -= mod_GRAFIKA_VSTUP_MOJEPLOCHA_X1;
      gMyUdlost.Y -= mod_GRAFIKA_VSTUP_MOJEPLOCHA_Y1;
      // schovn kurzoru myi
      MySchovejKurzor();
      // uloen zadanch hodnot do pole
      modCesta_SouadniceMst[modCesta_ZadvanMsto*2] = gMyUdlost.X;
      modCesta_SouadniceMst[modCesta_ZadvanMsto*2+1] = gMyUdlost.Y;
      }
    MyVypni();
    // vykreslen mapy - vechna zadan msta
    modCesta_VykresliMapu(0, -1);
    NastavJmnoBankyPedmt("*\\backtraq.mod\\"+AktivnModul->KrtkJmno);
    }

  // ZJITN POTU SPOJNIC, KTER JE MONO PI NAVTVOVN MST POUT
  mod_VypiHlku("Zadejte, kolik spojnic mezi msty chcete vloit [1-"+StrLslo(modCesta_PoetMst*(modCesta_PoetMst-1)/2,-1)+"]: ", mod_VYPIHLKU_NEEKEJ);
  if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
    while((VyprzdniFrontuKlves(),TxttiIslo(modCesta_PoetSpojnic)) || modCesta_PoetSpojnic < 1 || modCesta_PoetSpojnic > modCesta_PoetMst*(modCesta_PoetMst-1)/2);
    }
  else if(mod_ReimObrazovky == mod_GRAFICK_REIM) {
    GrNastavVstup(mod_GRAFIKA_VSTUP_POKYN);
    while((VyprzdniFrontuKlves(),GrtiIslo("",modCesta_PoetSpojnic,3,0,PalTmavModr<<4|Pallut)) || modCesta_PoetSpojnic < 1 || modCesta_PoetSpojnic > modCesta_PoetMst*(modCesta_PoetMst-1)/2);
    GrNastavVstup(mod_GRAFIKA_VSTUP_MOJEPLOCHA);
    }

  // INFORMACE O POTU SPOJNIC, KTER JE MONO PI NAVTVOVN MST POUT
  if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
    mod_VypiHlku("Budete vkldat "+StrLslo(modCesta_PoetSpojnic,-1)+" spojnic...", mod_VYPIHLKU_VYKEJ);
    }

  // PPRAVA POLE SPOJNIC
  // alokace pamti pro pole
  modCesta_Spojnice = (struct modCesta_TypSpojnice*)HromadaAlokujPam؜(modCesta_PoetSpojnic*sizeof(modCesta_Spojnice[0]));
  // vynulovn vech prvk pole
  memset(modCesta_Spojnice, 0, modCesta_PoetSpojnic*sizeof(modCesta_Spojnice[0]));

  // ZJITN, ZDA M BT HODNOTA ATRIBUTU SPOJNICE AUTOMATICKY NASTAVOVNA NA GRAFICKOU VZDLENOST MST, KTER SPOJUJE
  mod_NechZvolit_Volby[0] = "ano"; mod_NechZvolit_AccessKeys[0] = 'a';
  mod_NechZvolit_Volby[1] = "ne"; mod_NechZvolit_AccessKeys[1] = 'n';
  switch(mod_NechZvolit("Nastavovat atributy spojnic automaticky na jejich grafickou dlku v pixelech?")) {
    case 0: modCesta_AtributJeDlkaSpojnice = 1; break;
    case 1: modCesta_AtributJeDlkaSpojnice = 0; break;
    }

  // INFORMACE O TOM, ZDA M BT HODNOTA ATRIBUTU SPOJNICE AUTOMATICKY NASTAVOVNA NA GRAFICKOU VZDLENOST MST, KTER SPOJUJE
  if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
    mod_VypiHlku("Atributy spojnic "+(modCesta_AtributJeDlkaSpojnice?"budu":"nebudu")+" automaticky nastavovat na jejich grafickou dlkou...", mod_VYPIHLKU_VYKEJ);
    }

  // ZJITN INFORMAC O SPOJNICCH, KTER JE MONO PI NAVTVOVN MST POUT
  modCesta_VykresliMapu(0, -1);
  int modCesta_ZadvanSpojnice;
  int modCesta_ProchzenSpojnice;
  char modCesta_NatenZnak;
  for(modCesta_ZadvanSpojnice=0; modCesta_ZadvanSpojnice<modCesta_PoetSpojnic; modCesta_ZadvanSpojnice++) {
    // ZJITN PRVNHO Z MST TVOCCH PRV ZADVANOU SPOJNICI
    mod_VypiHlku("Zadejte psmenn oznaen prvnho z mst tvocho "+StrLslo(modCesta_ZadvanSpojnice+1,-1)+". spojnici [A-"+(string)(char)('A'+modCesta_PoetMst-1)+"]: ", mod_VYPIHLKU_NEEKEJ);
    if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
      while((VyprzdniFrontuKlves(),(modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto1=(int)((*(char*)StrNaVelk((string)(char)TxttiZnak()))-'A'))==-1) || modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto1 < 0 || modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto1 > modCesta_PoetMst-1);
      }
    else if(mod_ReimObrazovky == mod_GRAFICK_REIM) {
      GrNastavVstup(mod_GRAFIKA_VSTUP_POKYN);
      while((VyprzdniFrontuKlves(),GrtiZnak("",modCesta_NatenZnak,0,PalTmavModr<<4|Pallut)==-1||0*(modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto1=(int)((*(char*)StrNaVelk((string)modCesta_NatenZnak))-'A'))) || modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto1 < 0 || modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto1 > modCesta_PoetMst-1);
      GrNastavVstup(mod_GRAFIKA_VSTUP_MOJEPLOCHA);
      }

    // ZJITN DRUHHO Z MST TVOCCH PRV ZADVANOU SPOJNICI
    mod_VypiHlku("Zadejte psmenn oznaen druhho z mst tvocho "+StrLslo(modCesta_ZadvanSpojnice+1,-1)+". spojnici [A-"+(string)(char)('A'+modCesta_PoetMst-1)+"]: ", mod_VYPIHLKU_NEEKEJ);
    if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
      while((VyprzdniFrontuKlves(),(modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto2=(int)((*(char*)StrNaVelk((string)(char)TxttiZnak()))-'A'))==-1) || modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto2 < 0 || modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto2 > modCesta_PoetMst-1);
      }
    else if(mod_ReimObrazovky == mod_GRAFICK_REIM) {
      GrNastavVstup(mod_GRAFIKA_VSTUP_POKYN);
      while((VyprzdniFrontuKlves(),GrtiZnak("",modCesta_NatenZnak,0,PalTmavModr<<4|Pallut)==-1||0*(modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto2=(int)((*(char*)StrNaVelk((string)modCesta_NatenZnak))-'A'))) || modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto2 < 0 || modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto2 > modCesta_PoetMst-1);
      GrNastavVstup(mod_GRAFIKA_VSTUP_MOJEPLOCHA);
      }

    // KONTROLA PLATNOSTI PRV ZADVAN SPOJNICE
    // kontrola zadn neexistujc spojnice (vedouc z jednoho msta do stejnho)
    if(modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto1 == modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto2) {
      mod_VypiHlku("Chyba: Spojnice neme zanat i konit ve stejnm mst. Zadejte jinou.", mod_VYPIHLKU_EKEJNAKLVESUGRAFIKA);
      modCesta_ZadvanSpojnice--;
      continue;
      }

    // kontrola druhho zadvn ji jednou zadan spojnice
    for(modCesta_ProchzenSpojnice=0; modCesta_ProchzenSpojnice<modCesta_ZadvanSpojnice; modCesta_ProchzenSpojnice++) {
      if((modCesta_Spojnice[modCesta_ProchzenSpojnice].Msto1 == modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto1 &&
          modCesta_Spojnice[modCesta_ProchzenSpojnice].Msto2 == modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto2) ||
         (modCesta_Spojnice[modCesta_ProchzenSpojnice].Msto2 == modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto1 &&
          modCesta_Spojnice[modCesta_ProchzenSpojnice].Msto1 == modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto2)) {
        // zadvan spojnice ji byla zadna
        mod_VypiHlku("Chyba: Stejn spojnice ji byla dve zadna. Zadejte jinou.", mod_VYPIHLKU_EKEJNAKLVESUGRAFIKA);
        break;
        }
      }
    if(modCesta_ProchzenSpojnice < modCesta_ZadvanSpojnice) {
      modCesta_ZadvanSpojnice--;
      continue;
      }

    // ZJITN HODNOTY ATRIBUTU PRV ZADVAN SPOJNICE
    if(modCesta_AtributJeDlkaSpojnice) {
      // automatick nastaven atributu spojnice na grafickou vzdlenost mst, kter spojuje
      modCesta_Spojnice[modCesta_ZadvanSpojnice].Atribut = modCesta_ZjistiVzdlenostMst(modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto1, modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto2);
      }
    else {
      // run zadn hodnoty atributu spojnice
      mod_VypiHlku("Zadejte hodnotu atributu "+StrLslo(modCesta_ZadvanSpojnice+1,-1)+". spojnice [1-1000000]: ", mod_VYPIHLKU_NEEKEJ);
      if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
        while((VyprzdniFrontuKlves(),TxttiLslo(modCesta_Spojnice[modCesta_ZadvanSpojnice].Atribut)) || modCesta_Spojnice[modCesta_ZadvanSpojnice].Atribut < 1 || modCesta_Spojnice[modCesta_ZadvanSpojnice].Atribut > 1000000);
        }
      else if(mod_ReimObrazovky == mod_GRAFICK_REIM) {
        GrNastavVstup(mod_GRAFIKA_VSTUP_POKYN);
        while((VyprzdniFrontuKlves(),GrtiLslo("",modCesta_Spojnice[modCesta_ZadvanSpojnice].Atribut,7,0,PalTmavModr<<4|Pallut)) || modCesta_Spojnice[modCesta_ZadvanSpojnice].Atribut < 1 || modCesta_Spojnice[modCesta_ZadvanSpojnice].Atribut > 1000000);
        GrNastavVstup(mod_GRAFIKA_VSTUP_MOJEPLOCHA);
        }
      }

    // ZOBRAZEN PRV ZADVAN SPOJNICE SPOLU S JI ZADANMI
    if(mod_ReimObrazovky == mod_GRAFICK_REIM) {
      modCesta_VykresliMapu(0, -1);
      }

    // INFORMACE O PRV ZADVAN SPOJNICI
    if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
      mod_VypiHlku(StrLslo(modCesta_ZadvanSpojnice+1,-1)+". spojnice spojuje msta "+(string)(char)('A'+modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto1)+" a "+(string)(char)('A'+modCesta_Spojnice[modCesta_ZadvanSpojnice].Msto2)+" a m atribut hodnoty "+StrLslo(modCesta_Spojnice[modCesta_ZadvanSpojnice].Atribut,-1)+"...", mod_VYPIHLKU_VYKEJ);
      }
    }

  // ZJITN, JAK SOUET HODNOT ATRIBUT VECH SPOJNIC HLEDAT
  mod_NechZvolit_Volby[0] = "co nejmen"; mod_NechZvolit_AccessKeys[0] = 'm';
  mod_NechZvolit_Volby[1] = "co nejvt"; mod_NechZvolit_AccessKeys[1] = 'v';
  switch(mod_NechZvolit("Jak souet hodnot atribut vech spojnic na cest se m hledat?")) {
    case 0: modCesta_JakSouetSpojnicHledat = modCesta_NEJMEN_SOUET; break;
    case 1: modCesta_JakSouetSpojnicHledat = modCesta_NEJVT_SOUET; break;
    }

  // INFORMACE O TOM, JAK SOUET HODNOT ATRIBUT VECH SPOJNIC HLEDAT
  if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
    mod_VypiHlku("Budu hledat co "+(modCesta_JakSouetSpojnicHledat==modCesta_NEJMEN_SOUET?"nejmen":"nejvt")+" souet hodnot atribut vech spojnic na cest...", mod_VYPIHLKU_VYKEJ);
    }

  // ZJITN, KTER POZICE ZOBRAZOVAT
  mod_NechZvolit_Volby[0] = "jen een"; mod_NechZvolit_AccessKeys[0] = '';
  mod_NechZvolit_Volby[1] = "i prbh hledn"; mod_NechZvolit_AccessKeys[1] = 'p';
  switch(mod_NechZvolit("Zobrazovat jen nalezen een nebo i prbh hledn (upozornn: pomal)?")) {
    case 0: mod_ZobrazovanPozice = mod_POUZE_EEN; break;
    case 1: mod_ZobrazovanPozice = mod_VECHNY_POZICE; break;
    }

  // INFORMACE O TOM, KTER POZICE ZOBRAZOVAT
  if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
    mod_VypiHlku("Budu zobrazovat "+(mod_ZobrazovanPozice==mod_POUZE_EEN?"jen nalezen een":"i prbh hledn")+"...", mod_VYPIHLKU_VYKEJ);
    }

  // ZJITN, ZDA EKAT PO NALEZEN NOVHO NEJLEPHO EEN NA STISK KLVESY
  if(mod_ZobrazovanPozice == mod_POUZE_EEN) {
    // pokud se zobrazuje pouze vsledn nalezen een, po nalezen jednotlivch novch nejlepch een se nikdy neek
    mod_ekatNaKlvesu = 0;
    }
  else {
    mod_NechZvolit_Volby[0] = "ano, vykat"; mod_NechZvolit_AccessKeys[0] = 'a';
    mod_NechZvolit_Volby[1] = "ne, neekat"; mod_NechZvolit_AccessKeys[1] = 'n';
    switch(mod_NechZvolit("Vykat po nalezen novho nejlepho een na stisknut klvesy?")) {
      case 0: mod_ekatNaKlvesu = 1; break;
      case 1: mod_ekatNaKlvesu = 0; break;
      }

    // INFORMACE O TOM, ZDA PO NALEZEN NOVHO NEJLEPHO EEN EKAT NA STISK KLVESY
    if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
      mod_VypiHlku("Po nalezen novho nejlepho een "+(mod_ekatNaKlvesu?"budu":"nebudu")+" ekat na stisk klvesy...", mod_VYPIHLKU_VYKEJ);
      }
    }

  // ZJITN, ZDA ZAPISOVAT PROTOKOL O VPOTU DO SOUBORU
  mod_NechZvolit_Volby[0] = "ano, zapisovat"; mod_NechZvolit_AccessKeys[0] = 'a';
  mod_NechZvolit_Volby[1] = "ne, nezapisovat"; mod_NechZvolit_AccessKeys[1] = 'n';
  switch(mod_NechZvolit("Zapisovat protokol o vpotu do souboru?")) {
    case 0: mod_ZapisovatProtokol = 1; break;
    case 1: mod_ZapisovatProtokol = 0; break;
    }

  // INFORMACE O TOM, ZDA ZAPISOVAT PROTOKOL O VPOTU DO SOUBORU
  if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
    mod_VypiHlku("Protokol o vpotu "+(mod_ZapisovatProtokol?"budu":"nebudu")+" zapisovat do souboru...", mod_VYPIHLKU_VYKEJ);
    }

  if(mod_ZapisovatProtokol) {
    // ZJITN NZVU SOUBORU, KAM ZAPISOVAT PROTOKOL O VPOTU
    mod_VypiHlku("Zadejte nzev souboru: ", mod_VYPIHLKU_NEEKEJ);
    mod_ZapisovatProtokol_Nzev = "";
    if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
      TxtdkovEditor(mod_ZapisovatProtokol_Nzev,50,50,-1,0);
      TxtPiNovdek();
      }
    else if(mod_ReimObrazovky == mod_GRAFICK_REIM) {
      GrNastavVstup(mod_GRAFIKA_VSTUP_POKYN);
      VyprzdniFrontuKlves();
      GrdkovEditor(mod_ZapisovatProtokol_Nzev,50,-1,0,-1,PalTmavModr<<4|Pallut);
      GrNastavVstup(mod_GRAFIKA_VSTUP_MOJEPLOCHA);
      }
    if(StrKopie(mod_ZapisovatProtokol_Nzev, 1, 1) != ":") mod_ZapisovatProtokol_Nzev = "*\\" + mod_ZapisovatProtokol_Nzev;

    // INFORMACE O NZVU SOUBORU, KAM ZAPISOVAT PROTOKOL O VPOTU
    if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
      mod_VypiHlku("Zvolen soubor "+mod_ZapisovatProtokol_Nzev+"...", mod_VYPIHLKU_VYKEJ);
      }
    }
  }

void modCesta_OptimalizaceVstupu(void) {
  }

void modCesta_OpakovnInicializace(void) {
  modCesta_Cesta[modCesta_rove] = 0;
  }

int modCesta_OpakovnTest(void) {
  // kdy je jet jak spojnice prochzet (prochzen jet nebylo dokoneno)
  if(modCesta_Cesta[modCesta_rove] < modCesta_PoetSpojnic) {
    // pipoten hodnoty atributu prv prochzen spojnice k soutu hodnot atribut cel cesty
    modCesta_SouetSpojnic += modCesta_Spojnice[modCesta_Cesta[modCesta_rove]].Atribut;
    // vrcen informace o tom, e se m pokraovat v prochzen
    return 1;
    }
  else {
    // vrcen informace o tom, e prochzen ji bylo dokoneno
    return 0;
    }
  }

void modCesta_OpakovnIterace(void) {
  // odeten hodnoty atributu prv prochzen spojnice od soutu hodnot atribut cel cesty
  modCesta_SouetSpojnic -= modCesta_Spojnice[modCesta_Cesta[modCesta_rove]].Atribut;
  // pechod k nsledujc spojnici
  modCesta_Cesta[modCesta_rove]++;
  }

void modCesta_Dal硬lnek_Ped(void) {
  // zven rovn backtrackingu (poet spojnic v prv testovan cest)
  modCesta_rove++;
  }

void modCesta_Dal硬lnek_Po(void) {
  // zmenen rovn backtrackingu (poet spojnic v prv testovan cest)
  modCesta_rove--;
  }

int modCesta_TestVyhovuje(void) {
  int modCesta_ProchzenPrvek;
  struct modCesta_TypSpojnice modCesta_ProchzenSpojnice;

  // zjitn, zda nalezen pozice vyhovuje podmnkm lohy

  // kontrola, zda prv pidan spojnice navazuje na pedchoz spojnici
  struct modCesta_TypSpojnice modCesta_PedchozSpojnice;
  struct modCesta_TypSpojnice modCesta_PedpedchozSpojnice;
  int modCesta_NavazovanMsto;
  int modCesta_PidvanMsto;
  modCesta_ProchzenSpojnice = modCesta_Spojnice[modCesta_Cesta[modCesta_rove]];
  // zjitn pedchoz a pedpedchoz spojnice
  if(modCesta_rove == 0) {
    // pokud se jedn o prvn spojnici na cest
    modCesta_PedchozSpojnice.Msto1 = 0;
    modCesta_PedchozSpojnice.Msto2 = 0;
    modCesta_PedpedchozSpojnice.Msto1 = 0;
    modCesta_PedpedchozSpojnice.Msto2 = 0;
    }
  else if(modCesta_rove == 1) {
    // pokud se jedn o druhou spojnici na cest
    modCesta_PedchozSpojnice = modCesta_Spojnice[modCesta_Cesta[modCesta_rove-1]];
    modCesta_PedpedchozSpojnice.Msto1 = 0;
    modCesta_PedpedchozSpojnice.Msto2 = 0;
    }
  else {
    // pokud se nejedn o prvn ani o druhou spojnici na cest
    modCesta_PedchozSpojnice = modCesta_Spojnice[modCesta_Cesta[modCesta_rove-1]];
    modCesta_PedpedchozSpojnice = modCesta_Spojnice[modCesta_Cesta[modCesta_rove-2]];
    }
  // rozlien navazovanho a pidvanho msta
  if((modCesta_ProchzenSpojnice.Msto1 == modCesta_PedchozSpojnice.Msto1 && (modCesta_PedchozSpojnice.Msto2 == modCesta_PedpedchozSpojnice.Msto1 || modCesta_PedchozSpojnice.Msto2 == modCesta_PedpedchozSpojnice.Msto2)) ||
     (modCesta_ProchzenSpojnice.Msto1 == modCesta_PedchozSpojnice.Msto2 && (modCesta_PedchozSpojnice.Msto1 == modCesta_PedpedchozSpojnice.Msto1 || modCesta_PedchozSpojnice.Msto1 == modCesta_PedpedchozSpojnice.Msto2))) {
    modCesta_NavazovanMsto = modCesta_ProchzenSpojnice.Msto1;
    modCesta_PidvanMsto = modCesta_ProchzenSpojnice.Msto2;
    }
  else if((modCesta_ProchzenSpojnice.Msto2 == modCesta_PedchozSpojnice.Msto1 && (modCesta_PedchozSpojnice.Msto2 == modCesta_PedpedchozSpojnice.Msto1 || modCesta_PedchozSpojnice.Msto2 == modCesta_PedpedchozSpojnice.Msto2)) ||
     (modCesta_ProchzenSpojnice.Msto2 == modCesta_PedchozSpojnice.Msto2 && (modCesta_PedchozSpojnice.Msto1 == modCesta_PedpedchozSpojnice.Msto1 || modCesta_PedchozSpojnice.Msto1 == modCesta_PedpedchozSpojnice.Msto2))) {
    modCesta_NavazovanMsto = modCesta_ProchzenSpojnice.Msto2;
    modCesta_PidvanMsto = modCesta_ProchzenSpojnice.Msto1;
    }
  else {
    // vrcen informace, e nalezen pozice nevyhovuje podmnkm lohy
    return 0;
    }

  // kontrola, zda nkter z mst ji v cest obsaench nen shodn s mstem prv do cesty pidanm prostednictvm prv pidan spojnice
  for(modCesta_ProchzenPrvek=0; modCesta_ProchzenPrvek<modCesta_rove; modCesta_ProchzenPrvek++) {
    modCesta_ProchzenSpojnice = modCesta_Spojnice[modCesta_Cesta[modCesta_ProchzenPrvek]];
    if(modCesta_ProchzenSpojnice.Msto1 == modCesta_PidvanMsto || modCesta_ProchzenSpojnice.Msto2 == modCesta_PidvanMsto) {
      // vrcen informace, e nalezen pozice nevyhovuje podmnkm lohy
      return 0;
      }
    }

  // je testovan pozice stle lep ne doposud nejlep nalezen een?
  if(modCesta_JakSouetSpojnicHledat == modCesta_NEJMEN_SOUET && !(modCesta_SouetSpojnic < modCesta_Nejlepeen_SouetSpojnic)) {
    // ne, nen => pozice tedy nen vyhovujc (hled se jen to nejlep een)
    return 0;
    }
  // pozn.: pi hledn co nejvtho soutu nelze rozhodovat ji o kvalit stenho een (tj. na tomto mst), lze tak uinit a pi nalezen kompletnho een

  // zobrazen prv testovan pozice, pokud si uivatel toto nastavil
  if(mod_ZobrazovanPozice == mod_VECHNY_POZICE) {
    if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
      TxtPietzec(modCesta_PoleCestyNaetzec(modCesta_Cesta, &modCesta_rove, &modCesta_SouetSpojnic));
      TxtPiNovdek();
      }
    else if(mod_ReimObrazovky == mod_GRAFICK_REIM) {
      modCesta_VykresliMapu(modCesta_Cesta, modCesta_rove);
      if(modCesta_PoetSpojnic > 1 && modCesta_PoetSpojnic <= 10) ekej(1.0/modCesta_PoetSpojnic*6000-200);
      }
    if(mod_ZapisovatProtokol) {
      SouborPietzec(mod_ZapisovatProtokol_Soubor, "Testuji ");
      SouborPietzec(mod_ZapisovatProtokol_Soubor, modCesta_PoleCestyNaetzec(modCesta_Cesta, &modCesta_rove, &modCesta_SouetSpojnic));
      SouborPiNovdek(mod_ZapisovatProtokol_Soubor);
      }
    }

  // vrcen informace, e nalezen pozice vyhovuje podmnkm lohy
  return 1;
  }

int modCesta_TestNalezeno(void) {
  // nov kandidt na een byl nalezen, pokud je prv nalezen een kompletn
  struct modCesta_TypSpojnice modCesta_TestovanSpojnice;
  modCesta_TestovanSpojnice = modCesta_Spojnice[modCesta_Cesta[modCesta_rove]];
  return (modCesta_TestovanSpojnice.Msto1 == modCesta_PoetMst-1 || modCesta_TestovanSpojnice.Msto2 == modCesta_PoetMst-1);
  }

void modCesta_Nalezeno(void) {
  // je nalezen een lep ne doposud nejlep nalezen?
  if(modCesta_JakSouetSpojnicHledat == modCesta_NEJVT_SOUET && !(modCesta_SouetSpojnic > modCesta_Nejlepeen_SouetSpojnic)) {
    // ne, nen => een nem smysl zaznamenvat (hled se jen to nejlep)
    return;
    }
  // pozn.: pi hledn co nejvtho soutu nelze rozhodovat ji o kvalit stenho een (jako se tomu dje pi hledn nejmenho soutu), lze tak uinit a pi nalezen kompletnho een (tj. na tomto mst)
  // ano => uloen nalezenho een jako dosud nejlepho
  memmove(modCesta_Nejlepeen_Cesta, modCesta_Cesta, modCesta_PoetMst*sizeof(modCesta_Cesta[0]));
  modCesta_Nejlepeen_SouetSpojnic = modCesta_SouetSpojnic;
  modCesta_Nejlepeen_rove = modCesta_rove;
  // zobrazen prv nalezenho een
  if(mod_ReimObrazovky == mod_TEXTOV_REIM) {
    TxtPietzec("Nalezeno dosud nejlep een: ");
    TxtPietzec(modCesta_PoleCestyNaetzec(modCesta_Cesta, &modCesta_rove, &modCesta_SouetSpojnic));
    TxtPiNovdek();
    }
  else if(mod_ReimObrazovky == mod_GRAFICK_REIM) {
    mod_VypiHlku("Nalezeno dosud nejlep een: " + modCesta_PoleCestyNaetzec(modCesta_Cesta, &modCesta_rove, &modCesta_SouetSpojnic), mod_VYPIHLKU_NEEKEJ);
    if(mod_ZobrazovanPozice == mod_POUZE_EEN) modCesta_VykresliMapu(modCesta_Nejlepeen_Cesta, modCesta_Nejlepeen_rove);
    }
  // zpis prv nalezenho een do souboru, pokud si to uivatel pl
  if(mod_ZapisovatProtokol) {
    SouborPietzec(mod_ZapisovatProtokol_Soubor, "NALEZENO DOSUD NEJLEP EEN: ");
    SouborPietzec(mod_ZapisovatProtokol_Soubor, modCesta_PoleCestyNaetzec(modCesta_Cesta, &modCesta_rove, &modCesta_SouetSpojnic));
    SouborPiNovdek(mod_ZapisovatProtokol_Soubor);
    }
  // v ppad grafickho reimu, pokud se ale nezobrazuj pouze nalezen een, ppnut - oznmen nalezen novho nejlepho een
  if(mod_ReimObrazovky == mod_GRAFICK_REIM && !(mod_ZobrazovanPozice == mod_POUZE_EEN)) { Tn(1000); ekej(100); VypniTn(); }
  // vykn na stisk klvesy, pokud si to uivatel pl
  if(mod_ekatNaKlvesu) ekejNaKlvesu();
  }

void modCesta_InfoOModulu(struct _ModulInfo* ModulInfo) {
  ModulInfo->KrtkJmno = "Cesta";
  ModulInfo->DlouhJmno = "Hledn nejlep cesty";
  ModulInfo->Popis = "Pi cestovn se lovk asto ocitne v situaci, kdy m k dispozici nkolik rznch cest, ktermi se me vydat. Ideln samozejm je zvolit tu nejlep (nejkrat, asov nejmn nronou, nejlevnj...). Jak ji ale poznat, pokud se nkter z nabzejcch se cest jet dle rozdluj a jin naopak spojuj - kdy je s cest pli sloit? Tady letm pohled nepome, pro nalezen t nejlep cesty se prost mus vyzkouet vechny monosti. Tento modul vyuv algoritmus backtrackingu k vyhledn nejlep cesty za vs.";
  ModulInfo->Verze = 1.0;
  ModulInfo->Datum.Den = 20;
  ModulInfo->Datum.Msc = 9;
  ModulInfo->Datum.Rok = 2002;
  ModulInfo->Autor = "Marek Blahu";
  ModulInfo->Kontakt = "blahus@seznam.cz";
  ModulInfo->Start = &modCesta_Start;
  ModulInfo->Hotovo = &modCesta_Hotovo;
  ModulInfo->klid = &modCesta_klid;
  ModulInfo->ZadnVstupu = &modCesta_ZadnVstupu;
  ModulInfo->OptimalizaceVstupu = &modCesta_OptimalizaceVstupu;
  ModulInfo->OpakovnInicializace = &modCesta_OpakovnInicializace;
  ModulInfo->OpakovnTest = &modCesta_OpakovnTest;
  ModulInfo->OpakovnIterace = &modCesta_OpakovnIterace;
  ModulInfo->Dal硬lnek_Ped = &modCesta_Dal硬lnek_Ped;
  ModulInfo->Dal硬lnek_Po = &modCesta_Dal硬lnek_Po;
  ModulInfo->TestVyhovuje = &modCesta_TestVyhovuje;
  ModulInfo->TestNalezeno = &modCesta_TestNalezeno;
  ModulInfo->Nalezeno = &modCesta_Nalezeno;
  }
